/*///////////////////////////////////////////////////////////////////////////////////////////

	http://muhwa.com

	(c)2009 muhwa. all rights reserved.

/*/////////////////////////////////////////////////////////////////////////////////////////////


function MFUploader_OnLoad(sender){

	var host = sender.getHost();
	var control = host.content.MFUploader;

	var instance = MFUploader.instances[host.id];

	if(!instance)
		return ;

	instance.control = control;

	var opt = instance.options;

	control.setOption(opt);

	if(opt.onload)
		opt.onload();
}

var MFUploader = {
	
	id : 0,

	instances : {},

	getBinding : function(instance, fnc){
		return function(){
			return fnc.apply(instance, arguments);
		};
	},

	Extend : function(dest, src){
		for(var x in src){
			if(!dest[x])
				dest[x] = src[x];
		}
	},

	write : function(options, params){
		
		if(!options)
			options = {};
		
		if(!params)
			params = {};

		var rtn = new MFUploader_Instance('MFUploader' + (this.id++));
		
		this.instances[rtn.id] = rtn;

		MFUploader.Extend(params, {
			width : "63px",
			height : "21px",
			source : "MFUploader.xap",
			minRuntiomeVersion : "3.0.40723.0",
			autoUpgrade : "true",
			background : "#FFFFFF",
			maxFrameRate : "10",
			windowless : "true",
			onLoad : "MFUploader_OnLoad",
			message : "Install Silverlight",
			style : "position:relative;"
		});

		MFUploader.Extend(options, {
			ButtonURL : './btn.png',
			UploadURL : './upload.php',
			FileFiled : "FileFiled[]",

			tick : 100,
			delay : 0,
			multiple : true,

			filter : "Image Files (.png; .gif; .jpg)|*.png; *.gif; *.jpg|All Files (*.*)|*.*",

			onadd : function(file){
				return true;
			},
			onadded : function(file){
				return;
			},
			onprogress : function(file, info){
				info.filesend + " / " + info.filesize + "<br>" + info.totalsend + " / " + info.totalsize;
				return;
			},
			oncomplete : function(resp){
				alert(resp);
			},
			onstop : function(){
				return;
			},
			onerror : function(msg){
				alert("error : \n" + msg);
			}
		});

		for(var x in options){
			if(typeof options[x] == 'function'){
				options[x] = MFUploader.getBinding(rtn, options[x]);
			}
		}

		rtn.options = options;

		document.write([
			'<object id="'+rtn.id+'" data="data:application/x-silverlight-2,"  type="application/x-silverlight-2" width="'+params.width+'" height="'+params.height+'" style="'+params.style+'">',
				'<param name="source" value="'+params.source+'"/>',
				'<param name="background" value="'+params.background+'" />',
				'<param name="minRuntimeVersion" value="'+params.minRuntiomeVersion+'" />',
				'<param name="autoUpgrade" value="'+params.autoUpgrade+'" />',
				'<param name="maxFrameRate" value="'+params.maxFrameRate+'" />',
				'<param name="windowless" value="'+params.windowless+'" />',
				'<param name="onLoad" value="'+params.onLoad+'" />',
				'<a href="http://go.microsoft.com/fwlink/?LinkID=124807" style="color:black">',
					''+params.message+'',
				'</a>',
			'</object>'
		].join(""));

		return rtn;
	}

};

var MFUploader_Instance = function(id){
	this.id = id;
	this.control = null;
	this.options = null;
};

MFUploader_Instance.prototype = {
	notloaded : function(){
		alert("not loaded");
	},

	// upload
	upload : function(){
		if(!this.control)return notloaded();

		this.control.Upload();
	},
	
	stop : function(){
		if(!this.control)return notloaded();
		this.control.Stop();
	},

	reset : function(){
		if(!this.control)return notloaded();
		this.control.Reset();

	},

	// options
	setOption : function(name, value){
		if(!this.control)return notloaded();

		var opt = {};
		opt[name] = value;
		control.setOption(opt);
	},

	setUploadURL : function(value){
		if(!this.control)return notloaded();

		this.setOption("UploadURL", value);
	},

	setFilter : function(value){
		if(!this.control)return notloaded();

		this.setOption("filter", value);
	},

	// files
	getFiles : function(){
		if(!this.control)return notloaded();

		return this.control.files;
	},

	removeFile : function(idx){
		if(!this.control)return notloaded();

		this.control.files.splice(idx, 1);
	},

	removeAllFiles : function(){
		if(!this.control)return notloaded();

		this.control.files.splice(0, this.control.files.length);
	},


	// parameters
	addParam : function(name, value){
		if(!this.control)return notloaded();

		this.control.addParam(name, value);
	},
	
	removeParam : function(idx){
		if(!this.control)return notloaded();
		
		this.control.parameters.splice(idx, 1);
	},

	removeParamByName : function(name){
		if(!this.control)return notloaded();

		var params = this.control.parameters;

		for(var x = 0, len = params.length; x < len; x++){
			if(params[x].name == name){
				this.removeParam(x);
			}
		}
	},

	removeAllParams : function(){
		if(!this.control)return notloaded();

		this.control.parameters.splice(0, this.control.parameters.length);
	},

	setParams : function(params){
		if(!this.control)return notloaded();

		this.removeAllParams();

		for(var x in params){
			this.addParam(x, params[x]);
		}
	}

};
